
package br.ufsc.das.usage.nio;

import br.ufsc.das.util.Configuration;
import java.io.IOException;
import java.nio.ByteBuffer;


public class ProtocolDecoderAuth extends ProtocolDecoder{
    
    public static final byte SATX = 0x06;
    public static final byte RATX = 0x08;
    
    private byte[] bufferAuth = null;
    private int posAuth = 0;
    private int tamAuth = 0;
    
    public ProtocolDecoderAuth(){
    }
    
    public ReceivedPacket decode(ByteBuffer socketBuffer) throws IOException {
        while (socketBuffer.hasRemaining()) {
            if(newPckg){
                ctr = socketBuffer.get();
                tam = socketBuffer.getInt();
                tamAuth = socketBuffer.getInt();
                buffer = new byte[tam];
                bufferAuth = new byte[tamAuth];
                pos = 0;
                posAuth = 0;
                newPckg = false;
            }
            byte b = socketBuffer.get();
            if(pos < tam){
                buffer[pos] = b;
                pos++;
            }else{
                bufferAuth[posAuth] = b;
                posAuth++;
                if(posAuth >= tamAuth){
                    newPckg = true;
                    return new ReceivedPacket(ctr,buffer,bufferAuth);
                }
            }
            
        }
        return null;
    }
}