/*
 * Receiver.java
 *
 * Created on 10 de Maio de 2006, 11:03
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package br.ufsc.das;

import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.util.Configuration;
import br.ufsc.das.util.CommunicationSupport;
import br.ufsc.das.util.EventListener;

/**
 *
 * @author edualchieri
 */
public abstract class Receiver implements EventListener{
    
    protected CommunicationSupport support;
    
    /** Creates a new instance of Receiver */
    public Receiver(Configuration conf) {
        support = new CommunicationSupport(conf);
        try{
            support.setListener(this,conf.getPort(conf.getProcessId()));
        }catch(Exception e){
            e.printStackTrace();
        }
    }
    
    public abstract void deliver(ReceivedMessage data);
    
}
