package br.ufsc.das.demo;
import br.ufsc.das.*;
import br.ufsc.das.util.CommunicationSupport;
import br.ufsc.das.util.ReceivedMessage;
import br.ufsc.das.util.Configuration;
import br.ufsc.das.util.Storage;
import java.util.concurrent.Semaphore;
/*
 * Client.java
 *
 * Created on 2 de Fevereiro de 2006, 16:40
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

/**
 *
 * @author alchieri
 */
public class Client extends Connection{
    
    private Semaphore sm = new Semaphore(1);
    private Storage sto = new Storage(1000);
    private long t;
    /** Creates a new instance of Client */
    public Client() {
        super(new Configuration(1));
    }
    
    public void run(){
        for(int i=0;i<1000;i++){
           
            String s = "Ola "+i;
            
            
            s = s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s;
            s = s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s+s;
            s = s+s+s+s+s+s;
             
            //br.ufsc.das.util.Logger.println("Tamanho = "+s.getBytes().length);
            
            int[] targets = new int[1];
            targets[0] = 0;
            try{
                this.sm.acquire();
            }catch(Exception e){
               e.printStackTrace();
            }
            t = System.nanoTime();
            send(targets,s.getBytes());
        }
    }
    
    public void deliver(ReceivedMessage msg){
        sto.store(System.nanoTime() - t);        
        //br.ufsc.das.util.Logger.println("Client Recebeu "+new String(msg.getData()));
        
        
        if(sto.getCount() == 1000){
           //br.ufsc.das.util.Logger.println("Latencia Media: "+sto.getAverage(true));
           //br.ufsc.das.util.Logger.println("Desvio Padr�o: "+sto.getDP(true));
        }
        
        this.sm.release();
    }
    
    public static void main(String[] args){
        new Client().run();
    }
    
}
